/**@file
 *@brief	(strlcpy|strlcat) شؿ
 *@date		Fri,31 Oct,2008
 *@date		Thu,14 Oct,2010
 *@date		Wed,04 Sep,2013, Sun,15 Sep,2013
 *@author	Copyright(C)2008-2013 G-HAL
 *
 *@note
 *@verbatim
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

* Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

* Neither the name of the copyright holders nor the names of its contributors
may be used to endorse or promote products derived from this software
without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *@endverbatim
 */
#ifndef alternative_strlcpy_h_included_
#define alternative_strlcpy_h_included_

#if defined(HAVE_CONFIG_H)
# include "config.h"
#endif

#if defined(HAVE_SYS_TYPES_H)
# include <sys/types.h>
#endif
#if defined(HAVE_BSD_STRING_H)
# include <bsd/string.h>
#endif


#if (!defined(HAVE_STRICMP) && defined(HAVE_CONFIG_H)) || (!defined(HAVE_CONFIG_H) && !defined(MSDOS))
# define	stricmp		strcasecmp
# define	strnicmp	strncasecmp
#endif


#if (!defined(HAVE_STRLCPY) && defined(HAVE_CONFIG_H))
# if defined(HAVE_G_STRLCPY)
#  define	strlcpy	g_strlcpy
# elif defined(HAVE_LIBBSD)
# elif defined(HAVE_ALTERNATIVE_STRLCPY)
#  if defined(HAVE_STDDEF_H)
#   include <stddef.h>
#  endif
#  ifdef __cplusplus
extern "C" {
#  endif
extern size_t strlcpy(char *dst, const char *src, size_t size)
		__attribute__ ((__bounded__(__string__,1,3)));
#  ifdef __cplusplus
}
#  endif
#  define	ENABLE_ALTERNATIVE_STRLCPY
# else
#  error("A function strlcpy() or alternative function is required.")
# endif
#endif
#if (!defined(HAVE_STRLCAT) && defined(HAVE_CONFIG_H))
# if defined(HAVE_G_STRLCAT)
#  define	strlcat	g_strlcat
# elif defined(HAVE_LIBBSD)
# elif defined(HAVE_ALTERNATIVE_STRLCAT)
#  if defined(HAVE_STDDEF_H)
#   include <stddef.h>
#  endif
#  ifdef __cplusplus
extern "C" {
#  endif
extern size_t strlcat(char *dst, const char *src, size_t size)
		__attribute__ ((__bounded__(__string__,1,3)));
#  ifdef __cplusplus
}
#  endif
#  define	ENABLE_ALTERNATIVE_STRLCAT
# else
#  error("A function strlcat() or alternative function is required.")
# endif
#endif


#endif /* alternative_strlcpy_h_included_ */
/* [ End of File ] */
