/**@file
 *@brief	ĶξȰ
 *@date		Sat,31 Aug,2013 - Tue,03 Sep,2013
 *@date		Mon,16 Sep,2013, Sat,21 Sep,2013
 *@date		Mon,30 Sep,2013
 *@author	Copyright(C)2003-2013 G-HAL, All rights reserved.
 *
 *@note
 *@verbatim
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

* Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

* Neither the name of the copyright holders nor the names of its contributors
may be used to endorse or promote products derived from this software
without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *@endverbatim
 */
#ifndef args_h_included_
#define args_h_included_

#if defined(HAVE_CONFIG_H)
# include "config.h"
#endif

#if defined(HAVE_STDBOOL_H)
# include <stdbool.h>
#endif

#if !defined(__STDC_LIMIT_MACROS)
# define __STDC_LIMIT_MACROS
#endif
#if !defined(__STDC_CONSTANT_MACROS)
# define __STDC_CONSTANT_MACROS
#endif
#if defined(HAVE_STDINT_H)
# include <stdint.h>
#endif

#if defined(HAVE_LIMITS_H)
# include <limits.h>
#endif



#ifdef __cplusplus
extern "C" {
#endif



#if !defined(CANNA_AGENT_FLAGS)
# define	CANNA_AGENT_FLAGS	"CANNA_AGENT_FLAGS"	/**< ǥեȰꤹĶѿ */
#endif


/** Ķ
 */
struct args_t {
								/** ץ༫ȤδĶ */
	struct {
		char name[PATH_MAX];		/**< Υץ̾ */
	} env;

								/** 桼 */
	struct {
		bool anonymous;				/**< anonymous⡼ */
		char name[PATH_MAX];		/**< 桼̾ */
		char group[PATH_MAX];		/**< 롼̾ */
	} user;

								/** ʥץȥδĶ */
	struct {
		bool unicode;				/**< ֲUnicodeĥפѤ뤫ݤ */
		char* area_lang;			/**< ʥץȥǻꤹϰʬ */
		const char* codeset;		/**< ʥץȥѤ륳ɥå */
		char* locale;				/**< ʥץȥǻꤹ */
	} cannaprotocol;

								/** ɥåȾ */
	struct {
		const char* sourcecode;		/**< ɤΥɥå */
		const char* locale;			/**< ü */
		const char* internal;		/**< Υɥå */
	} codeset;

								/** ФȤ³ */
	struct {
		int domain;								/**< ³⡼ */
		char socket_name[PATH_MAX];				/**< ³å̾PF_UNIX⡼ɡ */
		char socket_name_fallback[PATH_MAX];	/**< ³å̾PF_UNIX⡼ɤ socket_name ̵ */
		char server_name[PATH_MAX];				/**< ³СPF_INET⡼ɡ */
		char service_name[PATH_MAX];			/**< ³ݡȡPF_INET⡼ɡ */
	} server;
};



/** Ķ
 */
extern struct args_t args;

extern bool init_args(void);
extern bool parse_args(int argc, char* const* const argv);
extern void fin_args(void);



#ifdef __cplusplus
}
#endif

#endif /* args_h_included_ */
/* [ End of File ] */
