/**@file
 *@brief	cannaץȥ򤷤٤ؿܥǡ
 *@date		Fri,23 Aug,2013 - Mon,09 Sep,2013
 *@date		Mon,30 Sep,2013
 *@author	Copyright(C)2013 G-HAL, All rights reserved.
 *
 *@note
 *@verbatim
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

* Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

* Neither the name of the copyright holders nor the names of its contributors
may be used to endorse or promote products derived from this software
without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *@endverbatim
 */
#ifndef cannaprotocol_common_h_included_
#define cannaprotocol_common_h_included_

#if defined(HAVE_CONFIG_H)
# include "config.h"
#endif

#if defined(HAVE_LIMITS_H)
# include <limits.h>
#endif
#if (CHAR_BIT != 8)
# error "This program requires that char bit is 8."
#endif

#if !defined(__STDC_LIMIT_MACROS)
# define __STDC_LIMIT_MACROS
#endif
#if !defined(__STDC_CONSTANT_MACROS)
# define __STDC_CONSTANT_MACROS
#endif
#if defined(HAVE_STDINT_H)
# include <stdint.h>
#endif

#if defined(HAVE_ASSERT_H)
# include <assert.h>
#endif

#if defined(HAVE_STRING_H)
# include <string.h>
#endif

#include "alternative_strlcpy.h"



#ifdef __cplusplus
extern "C" {
#endif



/** ʥץȥʸ󷿡EUC */
typedef uint8_t string8_t;

/** ʥץȥʸ󷿡磻ɥ饯 */
typedef uint16_t string16_t;


/** ʸ */
typedef uint32_t string_internal_t;

/** ʸ */
typedef uint_fast32_t string_internal_fast_t;



/** ФȤ̿ѾΡƥ
 */
struct canna_protocol_context_transaction_t {
	struct canna_protocol_transaction_t* cpt;			/**< ١ */
	struct canna_protocol_context_transaction_t* next;	/**< ƥȤΥꥹȡ */

	int_fast16_t context;				/**< ºݤ˻Ѥ륳ƥֹ */

	struct {
		int_fast16_t num;					/**<  */
		string8_t list[COM_READ_BUFSIZE];	/**< ̾ꥹ */
	} dic;								/**<  */

	struct {
		uint8_t w[COM_WRITE_BUFSIZE];		/**< ̿Хåե */
		uint8_t r[COM_READ_BUFSIZE];		/**< ̿Хåե */
	} buf;								/**< ̿Хåե */
};

/** ФȤ̿ѾΡ١
 */
struct canna_protocol_transaction_t {
	int sock;							/**< ̿ѥå */

	string8_t cannaprotocol_version[COM_WRITE_BUFSIZE];	/**< ץȥС */
	uint_fast16_t server_minor_version;	/**< ХޥʡС */
	string8_t user[COM_WRITE_BUFSIZE];	/**< 桼̾ */
	int_fast16_t initial_context;		/**< ƥֹʾܺ */

	struct canna_protocol_context_transaction_t* list_cpct;	/**< ƥȰ */

	struct {
		uint8_t w[COM_WRITE_BUFSIZE];		/**< ̿Хåե */
		uint8_t r[COM_READ_BUFSIZE];		/**< ̿Хåե */
	} buf;								/**< ̿Хåե */
};



/** string8_tʸĹ
 *@param[in]		ptr					ʸĹо
 *@return								ʸĹ
 *
 *@author	G-HAL
 *@date		Wed,04 Sep,2013
 */
inline static size_t string8len(const string8_t ptr[]) {
	assert (NULL != ptr);
	return strlen((const char* const)ptr);
}

/** string8_tʸ򥳥ԡ
 *@param[out]		dst					ԡ
 *@param[in]		src					ԡ
 *@param			len					祳ԡĹ
 *@return								ʸĹ
 *
 *@author	G-HAL
 *@date		Wed,04 Sep,2013
 */
inline static uint_fast16_t string8lcpy(string8_t dst[], const string8_t src[], uint_fast16_t len) {
	assert (NULL != dst);
	assert (NULL != src);
	return (uint_fast16_t)strlcpy((char* const)dst, (const char* const)src, (size_t)len);
}



#ifdef __cplusplus
}
#endif

#endif /* cannaprotocol_common_h_included_ */
/* [ End of File ] */
