/**@file
 *@brief	cannaץȥ򤷤٤ؿ顧ʸθν
 *@date		Sat,31 Aug,2013 - Tue,01 Oct,2013
 *@author	Copyright(C)2013 G-HAL, All rights reserved.
 *
 *@note
 *@verbatim
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

* Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

* Neither the name of the copyright holders nor the names of its contributors
may be used to endorse or promote products derived from this software
without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *@endverbatim
 */

#if defined(HAVE_CONFIG_H)
# include "config.h"
#endif

#if defined(HAVE_STDLIB_H)
# include <stdlib.h>
#endif
#if defined(HAVE_STDIO_H)
# include <stdio.h>
#endif
#if defined(HAVE_STDBOOL_H)
# include <stdbool.h>
#endif

#if defined(HAVE_ASSERT_H)
# include <assert.h>
#endif

#if !defined(__STDC_LIMIT_MACROS)
# define __STDC_LIMIT_MACROS
#endif
#if !defined(__STDC_CONSTANT_MACROS)
# define __STDC_CONSTANT_MACROS
#endif
#if defined(HAVE_STDINT_H)
# include <stdint.h>
#endif
#if !defined(__STDC_FORMAT_MACROS)
# define __STDC_FORMAT_MACROS
#endif
#if defined(HAVE_INTTYPES_H)
# include <inttypes.h>
#endif

#if defined(HAVE_ERRNO_H)
# include <errno.h>
#endif
#if defined(HAVE_STRING_H)
# include <string.h>
#endif
#if defined(HAVE_NETINET_IN_H)
# include <netinet/in.h> /* for OpenBSD, netinet/in.h must faster than arpa/inet.h */
#endif
#if defined(HAVE_ARPA_INET_H)
# include <arpa/inet.h>
#endif

#include "intl.h"
#include "logger.h"
#include "type_punned_cast.h"
#include "cannaprotocol_common.h"
#include "cannaprotocol_low_sub.h"
#include "cannaprotocol_low.h"



/** ʥץȥ롧׵
 *@param[in,out]	cpct					̿Ѿ
 *@param			cur_phrase			ʸֹ
 *@param[out]		num_candidacy		
 *@param[out]		candidacy_list		
 *@param			maxlen_candidacy_list	candidacy_list ˳ǼǤʸĹ
 *@param[out]		len_candidacy_list	candidacy_list ˳ǼʸĹ
 *@retval			true				
 *@retval			false				
 *
 *@author	G-HAL
 *@date		Sat,31 Aug,2013
 *@date		Fri,06 Sep,2013
 *@date		Tue,01 Oct,2013
 */
bool cannaprotocol_GetCandidacyList(struct canna_protocol_context_transaction_t* const cpct, int_fast16_t cur_phrase, int_fast16_t* const num_candidacy, string16_t* const candidacy_list, size_t maxlen_candidacy_list, size_t* const len_candidacy_list)
{
	assert (NULL != cpct);
	assert (NULL != num_candidacy);
	assert (NULL != candidacy_list);
	/* assert (NULL != len_candidacy_list); */

	{	/*  */
		void* ptr_write = cpct->buf.w;
		*((union type_punned_pointer_cast_t* const)&ptr_write)->u8p ++ = CannaProtocol_GetCandidacyList;
		*((union type_punned_pointer_cast_t* const)&ptr_write)->u8p ++ = UINT8_C(0x00);
		const size_t len_data = 6;
		*((union type_punned_pointer_cast_t* const)&ptr_write)->u16p ++ = htons((uint16_t)len_data);
		*((union type_punned_pointer_cast_t* const)&ptr_write)->s16p ++ = (int16_t)htons((uint16_t)cpct->context);
		*((union type_punned_pointer_cast_t* const)&ptr_write)->s16p ++ = (int16_t)htons((uint16_t)cur_phrase);
		*((union type_punned_pointer_cast_t* const)&ptr_write)->u16p ++ = htons(number_(cpct->buf.w) - 8);
		const size_t len_write = (4 + len_data);
		assert (len_write <= number_(cpct->buf.w));
		ssize_t ret_write = write(cpct->cpt->sock, cpct->buf.w, len_write);
		if (-1 == ret_write) {
			LOGGER_ERR(l,N_("write() failed at %1$s %2$s"), "cannaprotocol_GetCandidacyList()", strerror(errno));
			return false;
		}
		if (ret_write != (ssize_t)len_write) {
			LOGGER_ERR(l,N_("write() mismatch at %1$s %2$s"), "cannaprotocol_GetCandidacyList()", strerror(errno));
		}
	}
	{	/*  */
		const ssize_t len_read = cannaprotocol_check_result(cpct->cpt, CannaProtocol_GetCandidacyList, cpct->buf.r, (uint_fast16_t)number_(cpct->buf.r));
		void* ptr_read = &(cpct->buf.r[4]);
		if (len_read < 8) {
			LOGGER_ERR(l,N_("The reply size of the server is mismatch at %1$s %2$zd"), "cannaprotocol_GetCandidacyList()", len_read);
			return false;
		}
		const int_fast16_t dat_num = (int_fast16_t)ntohs(*((union type_punned_pointer_cast_t* const)&ptr_read)->u16p ++);
		if (-1 == dat_num) {
			LOGGER_ERR(l,N_("Convert failed at %1$s"), "cannaprotocol_GetCandidacyList()");
			return false;
		}
		(*num_candidacy) = dat_num;
		if (NULL != candidacy_list) {
			const size_t tmp_len_candidacy_list = (size_t)(len_read - 6);
			if (maxlen_candidacy_list < tmp_len_candidacy_list) {
				LOGGER_ERR(l,N_("Buffer overflow at %1$s"), "cannaprotocol_GetCandidacyList()");
				return false;
			}
			memcpy(candidacy_list, ptr_read, (sizeof(candidacy_list[0]) * tmp_len_candidacy_list));
			if (NULL != len_candidacy_list) {
				(*len_candidacy_list) = tmp_len_candidacy_list;
			}
		}
	}
	return true;
}



/** ʥץȥ롧ɤߤʼ
 *@param[in,out]	cpct					̿Ѿ
 *@param			cur_phrase			ʸֹ
 *@param[out]		yomi_str			̡NULL: ס
 *@param			maxlen_yomi_str		yomi_str ˳ǼǤʸĹ
 *@param[out]		len_yomi			
 *@retval			true				
 *@retval			false				
 *
 *@author	G-HAL
 *@date		Sun,01 Sep,2013
 *@date		Fri,06 Sep,2013
 */
bool cannaprotocol_GetYomi(struct canna_protocol_context_transaction_t* const cpct, int_fast16_t cur_phrase, string16_t* const yomi_str, size_t maxlen_yomi_str, int_fast16_t* const len_yomi)
{
	assert (NULL != cpct);
	/* assert (NULL != yomi_str); */
	assert (NULL != len_yomi);

	{	/*  */
		void* ptr_write = cpct->buf.w;
		*((union type_punned_pointer_cast_t* const)&ptr_write)->u8p ++ = CannaProtocol_GetYomi;
		*((union type_punned_pointer_cast_t* const)&ptr_write)->u8p ++ = UINT8_C(0x00);
		const size_t len_data = 6;
		*((union type_punned_pointer_cast_t* const)&ptr_write)->u16p ++ = htons((uint16_t)len_data);
		*((union type_punned_pointer_cast_t* const)&ptr_write)->s16p ++ = (int16_t)htons((uint16_t)cpct->context);
		*((union type_punned_pointer_cast_t* const)&ptr_write)->s16p ++ = (int16_t)htons((uint16_t)cur_phrase);
		*((union type_punned_pointer_cast_t* const)&ptr_write)->u16p ++ = htons(number_(cpct->buf.w) - 8);
		const size_t len_write = (4 + len_data);
		assert (len_write <= number_(cpct->buf.w));
		ssize_t ret_write = write(cpct->cpt->sock, cpct->buf.w, len_write);
		if (-1 == ret_write) {
			LOGGER_ERR(l,N_("write() failed at %1$s %2$s"), "cannaprotocol_GetYomi()", strerror(errno));
			return false;
		}
		if (ret_write != (ssize_t)len_write) {
			LOGGER_ERR(l,N_("write() mismatch at %1$s %2$s"), "cannaprotocol_GetYomi()", strerror(errno));
		}
	}
	{	/*  */
		const ssize_t len_read = cannaprotocol_check_result(cpct->cpt, CannaProtocol_GetYomi, cpct->buf.r, (uint_fast16_t)number_(cpct->buf.r));
		void* ptr_read = &(cpct->buf.r[4]);
		if (len_read < 8) {
			LOGGER_ERR(l,N_("The reply size of the server is mismatch at %1$s %2$zd"), "cannaprotocol_GetYomi()", len_read);
			return false;
		}
		const int_fast16_t dat_num = (int_fast16_t)ntohs(*((union type_punned_pointer_cast_t* const)&ptr_read)->u16p ++);
		if (-1 == dat_num) {
			LOGGER_ERR(l,N_("GetYomi failed at %1$s"), "cannaprotocol_GetYomi()");
			return false;
		}
		(*len_yomi) = dat_num;
		if (NULL != yomi_str) {
			const size_t len_yomi_str = (size_t)(len_read - 6);
			if (maxlen_yomi_str < len_yomi_str) {
				LOGGER_ERR(l,N_("Buffer overflow at %1$s"), "cannaprotocol_GetYomi()");
				return false;
			}
			memcpy(yomi_str, ptr_read, (sizeof(yomi_str[0]) * len_yomi_str));
		}
	}
	return true;
}



/** ʥץȥ롧ڤѹ
 *@param[in,out]	cpct					̿Ѿ
 *@param			phrase				ѹʸֹ
 *@param			new_len				ʸĹ
 *@param[out]		converted_str		Ѵ
 *@param			maxlen_converted_str	converted_str ˳ǼǤʸĹ
 *@param[out]		num_phrase			Ѵ̤ʸ
 *@retval			true				
 *@retval			false				
 *
 *@author	G-HAL
 *@date		Sun,01 Sep,2013
 *@date		Fri,06 Sep,2013
 */
bool cannaprotocol_ResizePause(struct canna_protocol_context_transaction_t* const cpct, int_fast16_t phrase, int_fast16_t new_len, string16_t* const converted_str, size_t maxlen_converted_str, int_fast16_t* const num_phrase)
{
	assert (NULL != cpct);
	assert (NULL != converted_str);
	assert (NULL != num_phrase);

	{	/*  */
		void* ptr_write = cpct->buf.w;
		*((union type_punned_pointer_cast_t* const)&ptr_write)->u8p ++ = CannaProtocol_ResizePause;
		*((union type_punned_pointer_cast_t* const)&ptr_write)->u8p ++ = UINT8_C(0x00);
		*((union type_punned_pointer_cast_t* const)&ptr_write)->u16p ++ = htons(6);
		*((union type_punned_pointer_cast_t* const)&ptr_write)->s16p ++ = (int16_t)htons((uint16_t)cpct->context);
		*((union type_punned_pointer_cast_t* const)&ptr_write)->s16p ++ = (int16_t)htons((uint16_t)phrase);
		*((union type_punned_pointer_cast_t* const)&ptr_write)->s16p ++ = (int16_t)htons((uint16_t)new_len);
		const size_t len_write = (4 + 6);
		assert (len_write <= number_(cpct->buf.w));
		ssize_t ret_write = write(cpct->cpt->sock, cpct->buf.w, len_write);
		if (-1 == ret_write) {
			LOGGER_ERR(l,N_("write() failed at %1$s %2$s"), "cannaprotocol_ResizePause()", strerror(errno));
			return false;
		}
		if (ret_write != (ssize_t)len_write) {
			LOGGER_ERR(l,N_("write() mismatch at %1$s %2$s"), "cannaprotocol_ResizePause()", strerror(errno));
		}
	}
	{	/*  */
		const ssize_t len_read = cannaprotocol_check_result(cpct->cpt, CannaProtocol_ResizePause, cpct->buf.r, (uint_fast16_t)number_(cpct->buf.r));
		void* ptr_read = &(cpct->buf.r[4]);
		if (len_read < 8) {
			LOGGER_ERR(l,N_("The reply size of the server is mismatch at %1$s %2$zd"), "cannaprotocol_ResizePause()", len_read);
			return false;
		}
		const int_fast16_t dat_num = (int_fast16_t)ntohs(*((union type_punned_pointer_cast_t* const)&ptr_read)->u16p ++);
		if (-1 == dat_num) {
			LOGGER_ERR(l,N_("Convert failed at %1$s"), "cannaprotocol_ResizePause()");
			return false;
		}
		(*num_phrase) = dat_num;
		if (NULL != converted_str) {
			const size_t len_converted_str = (size_t)(len_read - 6);
			if (maxlen_converted_str < len_converted_str) {
				LOGGER_ERR(l,N_("Buffer overflow at %1$s"), "cannaprotocol_ResizePause()");
				return false;
			}
			memcpy(converted_str, ptr_read, (sizeof(converted_str[0]) * len_converted_str));
		}
	}
	return true;
}

/* [ End of File ] */
