/**@file
 *@brief	anthy-agentץȥʹؿܥǡ
 *@date		Fri,23 Aug,2013 - Mon,16 Sep,2013
 *@date		Thu,19 Sep,2013
 *@date		Mon,30 Sep,2013 - Tue,01 Oct,2013
 *@author	Copyright(C)2013 G-HAL, All rights reserved.
 *
 *@note
 *@verbatim
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

* Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

* Neither the name of the copyright holders nor the names of its contributors
may be used to endorse or promote products derived from this software
without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *@endverbatim
 */
#ifndef parseline_common_h_included_
#define parseline_common_h_included_

#if defined(HAVE_CONFIG_H)
# include "config.h"
#endif

#if defined(HAVE_STDBOOL_H)
# include <stdbool.h>
#endif

#if !defined(__STDC_LIMIT_MACROS)
# define __STDC_LIMIT_MACROS
#endif
#if !defined(__STDC_CONSTANT_MACROS)
# define __STDC_CONSTANT_MACROS
#endif
#if defined(HAVE_STDINT_H)
# include <stdint.h>
#endif

#include "cannaprotocol_common.h"



#ifdef __cplusplus
extern "C" {
#endif



/** ϥ٥륳ޥɳʸ */
#define PARSELINE_HIGHCMD_START ' '

/** ޥɳʸ */
#define PARSELINE_KEYCMD_START '('
/** ޥɶڤʸ */
#define PARSELINE_KEYCMD_DELIMITER ' '
/** ޥɽλʸ */
#define PARSELINE_KEYCMD_END ')'

/** ľϤؤΰڤؤ */
#define PARSELINE_TOGGLE_KEY '/'



/** ϥơ
 */
enum input_state_t {
	PARSELINE_INPUT_STATE_INIT = 1,	/**<  */
	PARSELINE_INPUT_STATE_INPUT,	/**<  */
	PARSELINE_INPUT_STATE_CONV,		/**< Ѵ */
	PARSELINE_INPUT_STATE_EDITSEG,	/**< ʸڤԽ */
};

/** ޻- Ѵޥåסʼѡ */
struct rk_map_t {
	struct rk_map_t* next;						/**< ѴޥåפΥꥹ */
	char input[PENDING_BUFSIZE];				/**< Ϥ줿ʸ */
	size_t len_input;							/**< input[] ʸ */
	string_internal_t output[PENDING_BUFSIZE];	/**< Ϥʸ */
	char pending[PENDING_BUFSIZE];				/**< ڥǥ󥰤ʸ */
};

/** ޻- Ѵޥåץơ֥ */
struct rk_map_index_t {
	struct rk_map_t *rk_map[0x100];				/**< Ϥ줿Ƭʸ̤Ѵޥå */
};

/** ޻- Ѵޥåפΰ */
struct rk_map_tables_t {
	const int map_no;										/**< ޥåֹ */
	const char* const table_name;							/**< ơ֥̾ */
	const struct rk_map_source_t* const rk_map_source;		/**< ޥåסʥɵѡ */
	struct rk_map_index_t* rk_map_index;					/**< ޥåסʼѡ */
};

/** ϥѡνΡƥ
 */
struct agent_parser_context_transaction_t {
	struct agent_parser_transaction_t* apt;				/**< ١ */
	struct agent_parser_context_transaction_t* next;	/**< ƥȤΥꥹȡ */
	struct canna_protocol_context_transaction_t* cpct;	/**< ФȤ̿ */

	int id;										/**< ֹ */

	enum input_state_t input_state;				/**< ⡼ */
	const struct rk_map_tables_t* rk_map_table;	/**< Ѥ륭ޥåץơ֥ */
	char toggle_key;							/**< ľϤؤΰڤؤ */
	bool rk_map_direct_mode;					/**< ľϥ⡼ɤݤ */
	bool break_into_roman;						/**< break_into_roman⡼ɤݤ */
	bool preedit_mode;							/**< preedit_mode⡼ɤݤ */

	struct {
		char buf[INPUT_BUFSIZE];			/**< ޥɡRKȤ̤ѡϥХåե */
		char pending_str[INPUT_BUFSIZE];	/**< ޥɥѡѤߤ RK̤ѡϥХåե */
		int_fast16_t cursor_ptr;			/**< strΥ */
		string_internal_t str[INPUT_BUFSIZE];	/**< ޥ,RK ˥ѡѤߤΥ桼ϥХåե */
		char str_rk[INPUT_BUFSIZE][PENDING_BUFSIZE];	/**< str[] γʸ RK̤ѡ */
		int_fast16_t len;					/**< strͭǡĹ */

		struct {
			unsigned char buf[INPUT_BUFSIZE+1];	/**< ʥץȥȤ̿ʸѴ */
			string16_t str[INPUT_BUFSIZE+1];	/**< ɤߤʤʸ */
			int_fast16_t len;					/**< strͭǡĹ */
		} cp;								/**< ʥץȥȤ̿ѥХåե */

	} input;							/**< Υ桼 */

	struct {
		int_fast16_t num_phrase;			/**< ʸ */
		int_fast16_t cursor_ptr;			/**< ʸ */

		int_fast16_t ptr_yomi[MAX_PHRASE];				/**< ʸɤߤʤγϰ */
		int_fast16_t len_yomi[MAX_PHRASE];				/**< ʸɤߤʤĹ */
		int_fast16_t num_candidacy[MAX_PHRASE];			/**< ʸθ */
		int_fast16_t selected_candidacy[MAX_PHRASE];	/**< ʸθֹ */

		string_internal_t* str[MAX_PHRASE][MAX_CANDIDACY];		/**< ʸγƸʸ */
		int_fast16_t len_str[MAX_PHRASE][MAX_CANDIDACY];		/**< ʸγƸʸĹ */
		string_internal_t buf_str[MAX_CANDIDACY * INPUT_BUFSIZE];	/**< ʸγƸʸХåե */
		int_fast16_t len_candidacy_hinshi;						/**< ʻĹ */

		struct {
			unsigned char buf[INPUT_BUFSIZE+1];				/**< ʥץȥȤ̿ʸѴ */
			string16_t str[INPUT_BUFSIZE];					/**< Ƭ */
			string16_t candidacy_list[INPUT_BUFSIZE];		/**< ʸΰ */
			string16_t candidacy_hinshi[INPUT_BUFSIZE];		/**< ʻ */
		} cp;								/**< ʥץȥȤ̿ѥХåե */

	} converted;						/**< Ѵ */

	struct {
		char str[OUTPUT_BUFSIZE];			/**< ߥåȺʸ */
	} commit;							/**< ߥåȷ */

	struct {
		char before_locale[OUTPUT_BUFSIZE];	/**< Ѵ */
		char after_locale[OUTPUT_BUFSIZE];	/**< Ѵ */
	} output;							/**< ̤Υ桼ؤν */
};

/** ϥѡνΡ١
 */
struct agent_parser_transaction_t {
	struct canna_protocol_transaction_t* cpt;				/**< ФȤ̿ */
	struct agent_parser_context_transaction_t* list_apct;	/**< ƥȰ */
};



#ifdef __cplusplus
}
#endif

#endif /* parseline_common_h_included_ */
/* [ End of File ] */
