/**@file
 *@brief	anthy-agentץȥʹؿ顧ϥ٥륳ޥɤν
 *@date		Sun,08 Sep,2013 - Sun,22 Sep,2013
 *@author	Copyright(C)2013 G-HAL, All rights reserved.
 *
 *@note
 *@verbatim
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

* Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

* Neither the name of the copyright holders nor the names of its contributors
may be used to endorse or promote products derived from this software
without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *@endverbatim
 */

#if defined(HAVE_CONFIG_H)
# include "config.h"
#endif

#if defined(HAVE_STDLIB_H)
# include <stdlib.h>
#endif
#if defined(HAVE_STDIO_H)
# include <stdio.h>
#endif
#if defined(HAVE_STDBOOL_H)
# include <stdbool.h>
#endif

#if defined(HAVE_ASSERT_H)
# include <assert.h>
#endif

#if !defined(__STDC_LIMIT_MACROS)
# define __STDC_LIMIT_MACROS
#endif
#if !defined(__STDC_CONSTANT_MACROS)
# define __STDC_CONSTANT_MACROS
#endif
#if defined(HAVE_STDINT_H)
# include <stdint.h>
#endif
#if !defined(__STDC_FORMAT_MACROS)
# define __STDC_FORMAT_MACROS
#endif
#if defined(HAVE_INTTYPES_H)
# include <inttypes.h>
#endif

#if defined(HAVE_STRING_H)
# include <string.h>
#endif

#include "intl.h"
#include "logger.h"
#include "parseline_common.h"
#include "parseline_low_sub.h"
#include "parseline_cmd.h"



/** 桼Ϥˤ륳ޥɰʸ󢪥ѡ̡ˡ
 */
struct highcommand_str2func_list_t {
	const char* const tag;				/**< ޥʸ */
	bool (*func)(struct agent_parser_context_transaction_t* const apct, int argc, _unused const char* const buf[]);	/**< ޥɤ¹Ԥؿ */
};


/** 桼Ϥˤ륳ޥɰʸ󢪥ѡ̡
 */
static const struct highcommand_str2func_list_t highcommand_str2func_list[] = {
	{ "PRINT_CONTEXT",		parseline_highcmd_print_context		},
	{ "CHANGE_TOGGLE",		parseline_highcmd_change_toggle		},
	{ "SELECT_CONTEXT",		parseline_highcmd_select_context	},
	{ "RELEASE_CONTEXT",	parseline_highcmd_release_context	},
	{ "MAP_CLEAR",			parseline_highcmd_map_clear			},
	{ "MAP_EDIT",			parseline_highcmd_map_edit			},
	{ "MAP_SELECT",			parseline_highcmd_map_select		},
	{ "GET_CANDIDATE",		parseline_highcmd_get_candidate		},
	{ "SELECT_CANDIDATE",	parseline_highcmd_select_candidate	},
	{ "BREAK_INTO_ROMAN",	parseline_highcmd_break_into_roman	},
	{ "SET_PREEDIT_MODE",	parseline_highcmd_set_preedit_mode	},
	{ NULL,					NULL,								},
};



/** ϥ٥륳ޥɤѡ
 *@param[in,out]	apct				̿Ѿ
 *@param[in]		buf					Ϥ줿ʸ
 *
 *@author	G-HAL
 *@date		Sun,08 Sep,2013 - Wed,11 Sep,2013
 *@date		Thu,19 Sep,2013
 */
void parseline_highcmd(struct agent_parser_context_transaction_t* const apct, const char buf[])
{
	assert (NULL != apct);
	assert (NULL != buf);


	/* ʸʬ */
	char* args = strdup(buf);
	if (!args) {
		LOGGER_CRIT(l,N_("Out of memory at %1$s"), "parseline_highcmd()");
		abort();
	}

	int argc = 0;
	for (char* ptr = args; '\0' != (*ptr); ++ptr) {
		switch (*ptr) {
		case ' ':
		case '\t':
		case '\r':
			(*ptr) = ' ';
			++argc;
			break;
		case '\n':
			(*ptr) = '\0';
			break;
		default:
			break;
		}
	}

	const char** argv = malloc(sizeof(char*) * ((unsigned int)argc + 2));
	if (!argv || ((argc + 2) < 2)) {
		LOGGER_CRIT(l,N_("Out of memory at %1$s"), "parseline_highcmd()");
		abort();
	}

	const char** ap = argv;
	(*ap ++) = args;
	(*ap) = NULL;
	for (char* ptr = args; '\0' != (*ptr); ++ptr) {
		if (' ' == (*ptr)) {
			(*ptr ++) = '\0';
			(*ap ++) = ptr;
			(*ap) = NULL;
		}
	}

	/* ޥɤ򸡺¹ */
	bool hit = false;
	for (const struct highcommand_str2func_list_t* cmd = highcommand_str2func_list; NULL != cmd->tag; ++cmd) {
		if (0 == strcmp(cmd->tag, argv[0])) {
			hit = true;
			const bool ret_highcmd = (*cmd->func)(apct, argc, argv);
			if (!ret_highcmd) {
				parseline_show_err(apct);
			}
			break;
		}
	}
	if (!hit) {
		parseline_show_err(apct);
	}

	/*  */
	free(argv);
	free(args);
	return;
}

/* [ End of File ] */
