/**@file
 *@brief	anthy-agentץȥʹؿ顧ϥ٥륳ޥɤμ¹
 *@date		Sun,08 Sep,2013 - Tue,01 Oct,2013
 *@author	Copyright(C)2013 G-HAL, All rights reserved.
 *
 *@note
 *@verbatim
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

* Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

* Neither the name of the copyright holders nor the names of its contributors
may be used to endorse or promote products derived from this software
without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *@endverbatim
 */

#if defined(HAVE_CONFIG_H)
# include "config.h"
#endif

#if defined(HAVE_STDLIB_H)
# include <stdlib.h>
#endif
#if defined(HAVE_STDIO_H)
# include <stdio.h>
#endif
#if defined(HAVE_STDBOOL_H)
# include <stdbool.h>
#endif

#if defined(HAVE_ASSERT_H)
# include <assert.h>
#endif

#if !defined(__STDC_LIMIT_MACROS)
# define __STDC_LIMIT_MACROS
#endif
#if !defined(__STDC_CONSTANT_MACROS)
# define __STDC_CONSTANT_MACROS
#endif
#if defined(HAVE_STDINT_H)
# include <stdint.h>
#endif
#if !defined(__STDC_FORMAT_MACROS)
# define __STDC_FORMAT_MACROS
#endif
#if defined(HAVE_INTTYPES_H)
# include <inttypes.h>
#endif

#if defined(HAVE_STRING_H)
# include <string.h>
#endif
#if defined(HAVE_LIMITS_H)
# include <limits.h>
#endif

#include "intl.h"
#include "logger.h"
#include "args.h"
#include "iconv_wrapper.h"
#include "cannaprotocol_low.h"
#include "cannaprotocol_wchar.h"
#include "parseline_common.h"
#include "parseline_rk.h"
#include "parseline_low_sub.h"
#include "parseline_cmd.h"
#include "parseline.h"



/** ϥ٥륳ޥɡȤΥƥȤɽ
 *@param[in,out]	apct				̿Ѿ
 *@param			argc				ο
 *@param[in]		argv				
 *
 *@author	G-HAL
 *@date		Sun,08 Sep,2013
 *@date		Thu,19 Sep,2013
 */
bool parseline_highcmd_print_context(struct agent_parser_context_transaction_t* const apct, int argc, _unused const char* const argv[])
{
	assert (NULL != apct);
	assert (NULL != argv);
	if (0 != argc) {
		return false;
	}

	switch (apct->input_state) {
	case PARSELINE_INPUT_STATE_INIT:
	case PARSELINE_INPUT_STATE_INPUT:
		return true;
		break;
	case PARSELINE_INPUT_STATE_CONV:
	case PARSELINE_INPUT_STATE_EDITSEG:
		break;
	}

	bool ret = true;
	apct->output.before_locale[0] = '\0';

	/* ʸڤɽ */
	for (int_fast16_t phrase = 0; phrase < apct->converted.num_phrase; ++ phrase) {
		strlcat(apct->output.before_locale, "|", number_(apct->output.before_locale));

		parseline_conv_strinternal_to_charstr(apct->output.before_locale, number_(apct->output.before_locale), &(apct->input.str[apct->converted.ptr_yomi[phrase]]), apct->converted.len_yomi[phrase]);
	}
	strlcat(apct->output.before_locale, "\r\n", number_(apct->output.before_locale));

	/* ɽ */
	for (int_fast16_t phrase = 0; phrase < apct->converted.num_phrase; ++ phrase) {
		parseline_conv_strinternal_to_charstr(apct->output.before_locale, number_(apct->output.before_locale), &(apct->input.str[apct->converted.ptr_yomi[phrase]]), apct->converted.len_yomi[phrase]);

		strlcat(apct->output.before_locale, "(", number_(apct->output.before_locale));

		const int_fast16_t num_candidacy = apct->converted.num_candidacy[phrase];
		for (int_fast16_t candidacy = 0; candidacy < num_candidacy; ++candidacy) {
			parseline_conv_strinternal_to_charstr(apct->output.before_locale, number_(apct->output.before_locale), apct->converted.str[phrase][candidacy], apct->converted.len_str[phrase][candidacy]);
			strlcat(apct->output.before_locale, ":(", number_(apct->output.before_locale));
			const bool ret_cpgh = cannaprotocol_GetHinshi(apct->cpct, phrase, candidacy, &(apct->converted.len_candidacy_hinshi), apct->converted.cp.candidacy_hinshi, number_(apct->converted.cp.candidacy_hinshi));
			if (!ret_cpgh) {
				ret = false;
			}
			parseline_conv_wstr_to_charstr(apct->output.before_locale, number_(apct->output.before_locale), apct->converted.cp.candidacy_hinshi, apct->converted.len_candidacy_hinshi);
			strlcat(apct->output.before_locale, ") ,", number_(apct->output.before_locale));
		}

		strlcat(apct->output.before_locale, "):\r\n", number_(apct->output.before_locale));
	}

	wrapper_iconv(ENCODING_TABLE_INTERNAL2LOCALE, apct->output.after_locale, number_(apct->output.after_locale), apct->output.before_locale, strlen(apct->output.before_locale));
	fputs(apct->output.after_locale, stdout);
	return ret;
}



/** ϥ٥륳ޥɡľϤؤΰڤؤ
 *@param[in,out]	apct				̿Ѿ
 *@param			argc				ο
 *@param[in]		argv				
 *
 *@author	G-HAL
 *@date		Sun,08 Sep,2013
 */
bool parseline_highcmd_change_toggle(struct agent_parser_context_transaction_t* const apct, int argc, _unused const char* const argv[])
{
	assert (NULL != apct);
	assert (NULL != argv);
	if (1 != argc) {
		return false;
	}

	if (1 != strlen(argv[1])) {
		return false;
	}
	apct->toggle_key = argv[1][0];
	return true;
}



/** ϥ٥륳ޥɡƥڤؤ⤷Ϻ
 *@param[in,out]	apct				̿Ѿ
 *@param			argc				ο
 *@param[in]		argv				
 *
 *@author	G-HAL
 *@date		Sun,08 Sep,2013
 *@date		Mon,09 Sep,2013
 *@date		Thu,19 Sep,2013
 */
bool parseline_highcmd_select_context(struct agent_parser_context_transaction_t* const apct, int argc, _unused const char* const argv[])
{
	assert (NULL != apct);
	assert (NULL != argv);
	if (1 != argc) {
		return false;
	}

	int id = (int)strtol(argv[1], NULL, 10);

	bool hit = false;
	struct agent_parser_context_transaction_t* ptr = apct->apt->list_apct;
	for (; NULL != ptr; ptr = ptr->next) {
		if (id == ptr->id) {
			hit = true;
			break;
		}
	}
	if (hit) {
		/* ƥȤڤؤ */
		struct agent_parser_context_transaction_t* const old_next = ptr->next;
		ptr->next = apct->apt->list_apct;
		apct->apt->list_apct = ptr;
		bool hit_connect = false;
		for (struct agent_parser_context_transaction_t* connext_ptr = ptr->next; NULL != connext_ptr; connext_ptr = connext_ptr->next) {
			if (ptr == connext_ptr->next) {
				hit_connect = true;
				connext_ptr->next = old_next;
				break;
			}
		}
		if (!hit_connect) {
			LOGGER_EMERG(l,N_("Data list was broken at %1$s"), "parseline_highcmd_select_context()");
			return false;
		}

	} else {
		/* ƥȤκ */
		const struct agent_parser_context_transaction_t* const new_ptr = init_parser_context(apct->apt, id);
		if (NULL == new_ptr) {
			return false;
		}
	}
	parseline_show_ok(apct);
	return true;
}



/** ϥ٥륳ޥɡƥȲ
 *@param[in,out]	apct				̿Ѿ
 *@param			argc				ο
 *@param[in]		argv				
 *
 *@author	G-HAL
 *@date		Sun,08 Sep,2013
 *@date		Mon,09 Sep,2013
 *@date		Thu,19 Sep,2013
 */
bool parseline_highcmd_release_context(struct agent_parser_context_transaction_t* const apct, int argc, _unused const char* const argv[])
{
	assert (NULL != apct);
	assert (NULL != argv);
	if (0 != argc) {
		return false;
	}

	if ((NULL == apct->next) && (apct->apt->list_apct == apct)) {
		/* ǸΣ */
		parseline_keycmd_esc(apct);
		parseline_keycmd_esc(apct);
		parseline_show_ok(apct);
		return true;
	}

	fin_parser_context(apct);
	parseline_show_ok(apct);
	return true;
}



/** ϥ٥륳ޥɡޥåפΰѹ
 *@param[in,out]	apct				̿Ѿ
 *@param			argc				ο
 *@param[in]		argv				
 *
 *@author	G-HAL
 *@date		Sun,08 Sep,2013
 *@date		Wed,11 Sep,2013
 *@date		Thu,19 Sep,2013
 */
bool parseline_highcmd_map_clear(struct agent_parser_context_transaction_t* const apct, int argc, _unused const char* const argv[])
{
	assert (NULL != apct);
	assert (NULL != argv);
	if (1 != argc) {
		return false;
	}

	const int map = (int)strtol(argv[1], NULL, 10);

	bool hit = false;
	struct rk_map_tables_t* tbl;
	for (tbl = rk_map_tables; NULL != tbl->table_name; ++tbl) {
		if (map == tbl->map_no) {
			hit = true;
			break;
		}
	}
	if (!hit) {
		return false;
	}

	parseline_rk_clear_map(tbl);
	parseline_rk_build_map(tbl);

	parseline_show_ok(apct);
	return true;
}



/** ϥ٥륳ޥɡޥåפΰѹ
 *@param[in,out]	apct				̿Ѿ
 *@param			argc				ο
 *@param[in]		argv				
 *
 *@author	G-HAL
 *@date		Sun,08 Sep,2013
 *@date		Wed,11 Sep,2013
 *@date		Thu,19 Sep,2013
 *@date		Mon,30 Sep,2013
 */
bool parseline_highcmd_map_edit(struct agent_parser_context_transaction_t* const apct, int argc, _unused const char* const argv[])
{
	assert (NULL != apct);
	assert (NULL != argv);
	if ((argc < 2) || (3 < argc)) {
		return false;
	}

	const int map = (int)strtol(argv[1], NULL, 10);
	const char* const input = argv[2];
	const char* const output = (3 <= argc) ? argv[3] : "";
	const char* const pending = (4 <= argc) ? argv[4] : "";

	struct rk_map_index_t* rk_map_index = NULL;
	for (struct rk_map_tables_t* tbl = rk_map_tables; NULL != tbl->table_name; ++tbl) {
		if (map == tbl->map_no) {
			rk_map_index = tbl->rk_map_index;
			break;
		}
	}
	if (NULL == rk_map_index) {
		return false;
	}

	{
		struct rk_map_t* dst = malloc(sizeof(struct rk_map_t));
		if (NULL == dst) {
			LOGGER_CRIT(l,N_("Out of memory at %1$s"), "parseline_highcmd_map_edit()");
			return false;
		}
		dst->next = rk_map_index->rk_map[(unsigned char)input[0]];
		rk_map_index->rk_map[(unsigned char)input[0]] = dst;

		strlcpy(dst->input, input, number_(dst->input));
		strlcpy(dst->pending, pending, number_(dst->pending));

		string_internal_t* output_ptr = dst->output;
		for (const char* input_ptr = output; '\0' != (*input_ptr);) {

			const uint_fast8_t c0 = (uint_fast8_t)(                 ('\0' != *(input_ptr+0))  ? (unsigned char)*(input_ptr+0) : '\0');
			const uint_fast8_t c1 = (uint_fast8_t)((('\0' != c0) && ('\0' != *(input_ptr+1))) ? (unsigned char)*(input_ptr+1) : '\0');
			const uint_fast8_t c2 = (uint_fast8_t)((('\0' != c1) && ('\0' != *(input_ptr+2))) ? (unsigned char)*(input_ptr+2) : '\0');
			const uint_fast8_t c3 = (uint_fast8_t)((('\0' != c2) && ('\0' != *(input_ptr+3))) ? (unsigned char)*(input_ptr+3) : '\0');

			string_internal_fast_t str = '\0';
			size_t ptr_movelen = 0;
			if ((UINT8_C('\r') == c0) || (UINT8_C('\n') == c0)) {
				/* פʸ */
				break;

			} else if (!args.cannaprotocol.unicode) {
				/* EUC-JP */
				const int ptr_type_eucjp = cannaprotocol_is_char_eucjp_fast(c0, c1, c2);
				if (2 == ptr_type_eucjp) {
					str = cannaprotocol_eucjpG2_to_strinternal(c1);
					ptr_movelen = 2;

				} else if (3 == ptr_type_eucjp) {
					str = cannaprotocol_eucjpG3_to_strinternal(c1, c2);
					ptr_movelen = 3;

				} else if (1 == ptr_type_eucjp) {
					str = cannaprotocol_eucjpG1_to_strinternal(c0, c1);
					ptr_movelen = 2;

				} else {
					str = cannaprotocol_eucjpG0_to_strinternal(c0);
					ptr_movelen = 1;
				}

			} else if (args.cannaprotocol.unicode) {
				/* UTF-8 */
				const size_t ptr_type_utf8 = get_len_mchar(input_ptr, 4, ENCODING_UTF8);
				if (1 == ptr_type_utf8) {
					str = (string_internal_fast_t)c0;
					ptr_movelen = 1;
				} else if (2 == ptr_type_utf8) {
					str = ((string_internal_fast_t)c0 << 8) | (string_internal_fast_t)c1;
					ptr_movelen = 2;
				} else if (3 == ptr_type_utf8) {
					str = ((string_internal_fast_t)c0 << 16) | ((string_internal_fast_t)c1 << 8) | (string_internal_fast_t)c2;
					ptr_movelen = 3;
				} else if (4 == ptr_type_utf8) {
					str = ((string_internal_fast_t)c0 << 24) | ((string_internal_fast_t)c1 << 16) | ((string_internal_fast_t)c2 << 8) | (string_internal_fast_t)c3;
					ptr_movelen = 4;
				} else {
					/* Illigal State */
					str = (string_internal_fast_t)c0;
					ptr_movelen = 1;
				}

			} else {
				/* Illigal State */
				str = c0;
				ptr_movelen = 1;
			}

			(*output_ptr) = str;
			++ output_ptr;
			input_ptr += ptr_movelen;
		}
		(*output_ptr) = '\0';
	}

	parseline_show_ok(apct);
	return true;
}



/** ϥ٥륳ޥɡޥåפѹ
 *@param[in,out]	apct				̿Ѿ
 *@param			argc				ο
 *@param[in]		argv				
 *
 *@author	G-HAL
 *@date		Sun,08 Sep,2013
 *@date		Wed,11 Sep,2013
 *@date		Thu,19 Sep,2013
 */
bool parseline_highcmd_map_select(struct agent_parser_context_transaction_t* const apct, int argc, _unused const char* const argv[])
{
	assert (NULL != apct);
	assert (NULL != argv);
	if (1 != argc) {
		return false;
	}

	bool hit = false;
	for (const struct rk_map_tables_t* tbl = rk_map_tables; NULL != tbl->table_name; ++tbl) {
		if (0 == strcmp(argv[1], tbl->table_name)) {
			apct->rk_map_table = tbl;
			hit = true;
			break;
		}
	}
	if (!hit) {
		return false;
	}
	parseline_show_ok(apct);
	return true;
}



/** ϥ٥륳ޥɡꤷֹѴɽ
 *@param[in,out]	apct				̿Ѿ
 *@param			argc				ο
 *@param[in]		argv				
 *
 *@author	G-HAL
 *@date		Sun,08 Sep,2013
 */
bool parseline_highcmd_get_candidate(struct agent_parser_context_transaction_t* const apct, int argc, _unused const char* const argv[])
{
	assert (NULL != apct);
	assert (NULL != argv);
	if (1 != argc) {
		return false;
	}


	switch (apct->input_state) {
	case PARSELINE_INPUT_STATE_INIT:
	case PARSELINE_INPUT_STATE_INPUT:
		return false;
		break;
	case PARSELINE_INPUT_STATE_CONV:
		break;
	case PARSELINE_INPUT_STATE_EDITSEG:
		return false;
		break;
	}

	{
		const int_fast16_t phrase = apct->converted.cursor_ptr;
		int_fast16_t candidacy = (int_fast16_t)strtol(argv[1], NULL, 10);
		if (apct->converted.num_candidacy[phrase] <= candidacy) {
			candidacy = 0;
		} else if (candidacy < 0) {
			candidacy = apct->converted.num_candidacy[phrase] - 1;
		}
		apct->converted.selected_candidacy[phrase] = candidacy;

		parseline_show_candidate(apct, phrase);
	}
	return true;
}



/** ϥ٥륳ޥɡѴֹ
 *@param[in,out]	apct				̿Ѿ
 *@param			argc				ο
 *@param[in]		argv				
 *
 *@author	G-HAL
 *@date		Sun,08 Sep,2013
 */
bool parseline_highcmd_select_candidate(struct agent_parser_context_transaction_t* const apct, int argc, _unused const char* const argv[])
{
	assert (NULL != apct);
	assert (NULL != argv);
	if (1 != argc) {
		return false;
	}


	switch (apct->input_state) {
	case PARSELINE_INPUT_STATE_INIT:
	case PARSELINE_INPUT_STATE_INPUT:
		return false;
		break;
	case PARSELINE_INPUT_STATE_CONV:
		break;
	case PARSELINE_INPUT_STATE_EDITSEG:
		return false;
		break;
	}

	{
		const int_fast16_t phrase = apct->converted.cursor_ptr;
		int_fast16_t candidacy = (int_fast16_t)strtol(argv[1], NULL, 10);
		if (apct->converted.num_candidacy[phrase] <= candidacy) {
			candidacy = 0;
		} else if (candidacy < 0) {
			candidacy = apct->converted.num_candidacy[phrase] - 1;
		}
		apct->converted.selected_candidacy[phrase] = candidacy;
	}
	parseline_show_stat(apct);
	return true;
}



/** ϥ٥륳ޥɡʸrk̤Ѵޤʬ򤹤⡼
 *@param[in,out]	apct				̿Ѿ
 *@param			argc				ο
 *@param[in]		argv				
 *
 *@author	G-HAL
 *@date		Sun,08 Sep,2013, Sat,14 Sep,2013
 *@date		Thu,19 Sep,2013
 */
bool parseline_highcmd_break_into_roman(struct agent_parser_context_transaction_t* const apct, int argc, _unused const char* const argv[])
{
	assert (NULL != apct);
	assert (NULL != argv);
	if (1 != argc) {
		return false;
	}


	if (1 != strlen(argv[1])) {
		return false;
	}
	switch (argv[1][0]) {
	case '0':
		apct->break_into_roman = false;
		parseline_show_ok(apct);
		return true;
		break;

	case '1':
		apct->break_into_roman = true;
		parseline_show_ok(apct);
		return true;
		break;

	default:
		return false;
		break;
	}
	return false;
}



/** ϥ٥륳ޥɡrkѴ̤Ǥɽ⡼
 *@param[in,out]	apct				̿Ѿ
 *@param			argc				ο
 *@param[in]		argv				
 *
 *@author	G-HAL
 *@date		Sun,08 Sep,2013, Mon,16 Sep,2013
 *@date		Thu,19 Sep,2013
 */
bool parseline_highcmd_set_preedit_mode(struct agent_parser_context_transaction_t* const apct, int argc, _unused const char* const argv[])
{
	assert (NULL != apct);
	assert (NULL != argv);
	if (1 != argc) {
		return false;
	}


	if (1 != strlen(argv[1])) {
		return false;
	}
	switch (argv[1][0]) {
	case '0':
		apct->preedit_mode = false;
		parseline_show_ok(apct);
		return true;
		break;

	case '1':
		apct->preedit_mode = true;
		parseline_show_ok(apct);
		return true;
		break;

	default:
		return false;
		break;
	}
	return false;
}

/* [ End of File ] */
