/**@file
 *@brief	anthy-agentץȥʹؿ顧ޥɤμ¹
 *@date		Fri,23 Aug,2013 - Tue,01 Oct,2013
 *@author	Copyright(C)2013 G-HAL, All rights reserved.
 *
 *@note
 *@verbatim
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

* Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

* Neither the name of the copyright holders nor the names of its contributors
may be used to endorse or promote products derived from this software
without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *@endverbatim
 */

#if defined(HAVE_CONFIG_H)
# include "config.h"
#endif

#if defined(HAVE_STDLIB_H)
# include <stdlib.h>
#endif
#if defined(HAVE_STDIO_H)
# include <stdio.h>
#endif
#if defined(HAVE_STDBOOL_H)
# include <stdbool.h>
#endif

#if defined(HAVE_ASSERT_H)
# include <assert.h>
#endif

#if !defined(__STDC_LIMIT_MACROS)
# define __STDC_LIMIT_MACROS
#endif
#if !defined(__STDC_CONSTANT_MACROS)
# define __STDC_CONSTANT_MACROS
#endif
#if defined(HAVE_STDINT_H)
# include <stdint.h>
#endif
#if !defined(__STDC_FORMAT_MACROS)
# define __STDC_FORMAT_MACROS
#endif
#if defined(HAVE_INTTYPES_H)
# include <inttypes.h>
#endif

#if defined(HAVE_STRING_H)
# include <string.h>
#endif
#if defined(HAVE_NETINET_IN_H)
# include <netinet/in.h> /* for OpenBSD, netinet/in.h must faster than arpa/inet.h */
#endif
#if defined(HAVE_ARPA_INET_H)
# include <arpa/inet.h>
#endif

#include "args.h"
#include "iconv_wrapper.h"
#include "parseline_low_sub.h"
#include "parseline_common.h"
#include "parseline_cmd.h"
#include "cannaprotocol_wchar.h"
#include "cannaprotocol_common.h"
#include "cannaprotocol_low.h"



/** Ѵ̼
 *@param[in,out]	apct				̿Ѿ
 *
 *@author	G-HAL
 *@date		Fri,30 Aug,2013 - Sun,01 Sep,2013
 *@date		Mon,02 Sep,2013, Fri,06 Sep,2013
 *@date		Tue,01 Oct,2013
 */
bool parseline_get_candidacy(struct agent_parser_context_transaction_t* const apct)
{
	assert (NULL != apct);
	assert (apct->converted.num_phrase < MAX_PHRASE);

	string_internal_t* converted_str_ptr = apct->converted.buf_str;
	size_t limit_converted_str = number_(apct->converted.buf_str);
	int_fast16_t len_converted_str = 0;
	for (int_fast16_t phrase = 0; phrase < apct->converted.num_phrase; ++phrase) {
		apct->converted.ptr_yomi[phrase] = len_converted_str;

		/*  */
		size_t len_candidacy_list;
		const bool ret_cpgcl = cannaprotocol_GetCandidacyList(apct->cpct, phrase, &(apct->converted.num_candidacy[phrase]), apct->converted.cp.candidacy_list, number_(apct->converted.cp.candidacy_list), &len_candidacy_list);
		if (!ret_cpgcl) {
			return false;
		}

		/* 򤫤ʥץȥѴ */
		if (!args.cannaprotocol.unicode) {
			/* EUC-JP */
			const string16_t* ptr_str16 = apct->converted.cp.candidacy_list;
			for (int_fast16_t candidacy = 0; candidacy < apct->converted.num_candidacy[phrase]; ++candidacy) {
				int_fast16_t len_candidacy_str = 0;

				apct->converted.str[phrase][candidacy] = converted_str_ptr;
				for (; '\0' != ptr_str16[0]; ++ptr_str16) {
					if (limit_converted_str < 4) {
						return false;
					}
					(*converted_str_ptr ++) = cannaprotocol_wchar_to_eucjp(ntohs(*ptr_str16));
					++ len_candidacy_str;
					-- limit_converted_str;
				}
				++ ptr_str16;
				(*converted_str_ptr ++) = '\0';
				apct->converted.len_str[phrase][candidacy] = len_candidacy_str;
			}
			(*converted_str_ptr ++) = '\0';

		} else {
			/* UTF-8 */
			wrapper_iconv(ENCODING_TABLE_CANNAPROTOCOL2INTERNAL, (char*)apct->converted.cp.buf, sizeof(apct->converted.cp.buf), (char*)apct->converted.cp.candidacy_list, len_candidacy_list);
			const unsigned char* ptr_str = apct->converted.cp.buf;
			for (int_fast16_t candidacy = 0; candidacy < apct->converted.num_candidacy[phrase]; ++candidacy) {
				int_fast16_t len_candidacy_str = 0;

				apct->converted.str[phrase][candidacy] = converted_str_ptr;
				for (; '\0' != ptr_str[0]; /* */ ) {
					if (limit_converted_str < 4) {
						return false;
					}
					const uint_fast8_t c0 = (uint_fast8_t)(                 ('\0' != *(ptr_str+0))  ? (unsigned char)*(ptr_str+0) : '\0');
					const uint_fast8_t c1 = (uint_fast8_t)((('\0' != c0) && ('\0' != *(ptr_str+1))) ? (unsigned char)*(ptr_str+1) : '\0');
					const uint_fast8_t c2 = (uint_fast8_t)((('\0' != c1) && ('\0' != *(ptr_str+2))) ? (unsigned char)*(ptr_str+2) : '\0');
					const uint_fast8_t c3 = (uint_fast8_t)((('\0' != c2) && ('\0' != *(ptr_str+3))) ? (unsigned char)*(ptr_str+3) : '\0');
					const size_t ptr_type_utf8 = get_len_mchar((const char*)ptr_str, 4, ENCODING_UTF8);
					size_t ptr_movelen = 1;
					if (1 == ptr_type_utf8) {
						(*converted_str_ptr ++) = (string_internal_fast_t)c0;
						ptr_movelen = 1;
					} else if (2 == ptr_type_utf8) {
						(*converted_str_ptr ++) = ((string_internal_fast_t)c0 << 8) | (string_internal_fast_t)c1;
						ptr_movelen = 2;
					} else if (3 == ptr_type_utf8) {
						(*converted_str_ptr ++) = ((string_internal_fast_t)c0 << 16) | ((string_internal_fast_t)c1 << 8) | (string_internal_fast_t)c2;
						ptr_movelen = 3;
					} else if (4 == ptr_type_utf8) {
						(*converted_str_ptr ++) = ((string_internal_fast_t)c0 << 24) | ((string_internal_fast_t)c1 << 16) | ((string_internal_fast_t)c2 << 8) | (string_internal_fast_t)c3;
						ptr_movelen = 4;
					} else {
						/* Illigal State */
						(*converted_str_ptr ++) = (string_internal_fast_t)c0;
						ptr_movelen = 1;
					}
					ptr_str += ptr_movelen;
					++ len_candidacy_str;
					-- limit_converted_str;
				}
				++ ptr_str;
				(*converted_str_ptr ++) = '\0';
				apct->converted.len_str[phrase][candidacy] = len_candidacy_str;
			}
			(*converted_str_ptr ++) = '\0';
		}

		const bool ret_cpgy = cannaprotocol_GetYomi(apct->cpct, phrase, NULL, (size_t)0, &(apct->converted.len_yomi[phrase]));
		if (!ret_cpgy) {
			return false;
		}
		len_converted_str += apct->converted.len_yomi[phrase];
	}
	(*converted_str_ptr ++) = '\0';

	return true;
}



/** ޥɡ
 *@param[in,out]	apct				̿Ѿ
 *
 *@author	G-HAL
 *@date		Wed,28 Aug,2013, Fri,30 Aug,2013 - Mon,02 Sep,2013
 *@date		Thu,05 Sep,2013
 */
void parseline_keycmd_commit(struct agent_parser_context_transaction_t* const apct)
{
	assert (NULL != apct);

	{
		switch (apct->input_state) {
		case PARSELINE_INPUT_STATE_INIT:
		case PARSELINE_INPUT_STATE_INPUT:
			parseline_conv_strinternal_to_charstr(apct->commit.str, number_(apct->commit.str), apct->input.str, apct->input.len);
			break;

		case PARSELINE_INPUT_STATE_CONV:
		case PARSELINE_INPUT_STATE_EDITSEG:
			{
				const bool ret_cp = cannaprotocol_EndConvert(apct->cpct, !(args.user.anonymous), apct->converted.num_phrase, apct->converted.selected_candidacy);
				if (ret_cp) {
					for (int_fast16_t phrase = 0; phrase < apct->converted.num_phrase; ++ phrase) {
						const int_fast16_t selected_candidacy = apct->converted.selected_candidacy[phrase];
						parseline_conv_strinternal_to_charstr(apct->commit.str, number_(apct->commit.str), apct->converted.str[phrase][selected_candidacy], apct->converted.len_str[phrase][selected_candidacy]);
					}
				}
			}
			break;
		}
	}

	{
		apct->input.pending_str[0] = '\0';
		apct->input.len = 0;
		apct->input.cursor_ptr = 0;
		apct->input_state = PARSELINE_INPUT_STATE_INIT;
	}
	return;
}



/** ޥɡѴϡ䡿
 *@param[in,out]	apct				̿Ѿ
 *@param			dir					-1, +1
 *
 *@author	G-HAL
 *@date		Sun,25 Aug,2013, Fri,30 Aug,2013 - Sun,01 Sep,2013
 *@date		Thu,19 Sep,2013
 *@date		Mon,30 Sep,2013 - Tue,01 Oct,2013
 */
void parseline_keycmd_arrow_ud(struct agent_parser_context_transaction_t* const apct, int dir)
{
	assert (NULL != apct);

	apct->input.pending_str[0] = '\0';

	switch (apct->input_state) {
	case PARSELINE_INPUT_STATE_INIT:
		break;

	case PARSELINE_INPUT_STATE_INPUT:
		{
			/* Ƥ򤫤ʥץȥѴ */
			if (!args.cannaprotocol.unicode) {
				/* EUC-JP */
				apct->input.cp.len = apct->input.len;
				for (int_fast16_t i = 0; i < apct->input.len; ++i) {
					apct->input.cp.str[i] = (string16_t)htons(cannaprotocol_eucjp_to_wchar_fast(apct->input.str[i]));
				}
				apct->input.cp.str[apct->input.cp.len] = '\0';

			} else {
				/* UTF-8 */
				size_t len_buf = 0;
				unsigned char* ptr = apct->input.cp.buf;
				for (int_fast16_t i = 0; i < apct->input.len; ++i) {
					const string_internal_fast_t c = apct->input.str[i];
					const uint_fast8_t c0 = ((uint_fast8_t)(c >>  0) & UINT8_C(0xFF));
					const uint_fast8_t c1 = ((uint_fast8_t)(c >>  8) & UINT8_C(0xFF));
					const uint_fast8_t c2 = ((uint_fast8_t)(c >> 16) & UINT8_C(0xFF));
					const uint_fast8_t c3 = ((uint_fast8_t)(c >> 24) & UINT8_C(0xFF));
					if (c3) {
						len_buf += 4;
						(*ptr ++) = (uint8_t)c3;
						(*ptr ++) = (uint8_t)c2;
						(*ptr ++) = (uint8_t)c1;
						(*ptr ++) = (uint8_t)c0;
					} else if (c2) {
						len_buf += 3;
						(*ptr ++) = (uint8_t)c2;
						(*ptr ++) = (uint8_t)c1;
						(*ptr ++) = (uint8_t)c0;
					} else if (c1) {
						len_buf += 2;
						(*ptr ++) = (uint8_t)c1;
						(*ptr ++) = (uint8_t)c0;
					} else {
						len_buf += 1;
						(*ptr ++) = (uint8_t)c0;
					}
				}
				(*ptr ++) = '\0';
				const size_t len_converted = wrapper_iconv(ENCODING_TABLE_INTERNAL2CANNAPROTOCOL, (char*)apct->input.cp.str, sizeof(apct->input.cp.str), (char*)apct->input.cp.buf, len_buf);
				apct->input.cp.len = (int_fast16_t)(len_converted / 2);
				apct->input.cp.str[apct->input.cp.len] = '\0';
			}

			/* Ѵ̤ɤ߽Ф */
			const bool ret_cpbc = cannaprotocol_BeginConvert(apct->cpct, apct->input.cp.str, apct->input.cp.len, apct->converted.cp.str, number_(apct->converted.cp.str), &(apct->converted.num_phrase));
			if (ret_cpbc) {
				const bool ret_cp_getcandidacy = parseline_get_candidacy(apct);
				if (!ret_cp_getcandidacy) {
					goto CONVERT_FAILED;
				}
				for (int_fast16_t phrase = 0; phrase < apct->converted.num_phrase; ++phrase) {
					apct->converted.selected_candidacy[phrase] = 0;
				}
				apct->converted.cursor_ptr = 0;
				if (dir < 0) {
					apct->converted.selected_candidacy[0] = apct->converted.num_candidacy[0] - 1;
				}
				apct->input_state = PARSELINE_INPUT_STATE_CONV;

			} else {
CONVERT_FAILED:
				parseline_show_err(apct);
				const bool ret_cp = cannaprotocol_EndConvert(apct->cpct, false, 0, apct->converted.selected_candidacy);
				if (!ret_cp) {
				}
			}
		}
		break;

	case PARSELINE_INPUT_STATE_CONV:
		{
			const int_fast16_t phrase = apct->converted.cursor_ptr;
			int_fast16_t candidacy = apct->converted.selected_candidacy[phrase];
			candidacy += dir;
			if (apct->converted.num_candidacy[phrase] <= candidacy) {
				candidacy = 0;
			} else if (candidacy < 0) {
				candidacy = apct->converted.num_candidacy[phrase] - 1;
			}
			apct->converted.selected_candidacy[phrase] = candidacy;
		}
		break;

	case PARSELINE_INPUT_STATE_EDITSEG:
		{
			const int_fast16_t phrase = apct->converted.cursor_ptr;
			apct->converted.selected_candidacy[phrase] = 0;
			apct->input_state = PARSELINE_INPUT_STATE_CONV;
		}
		break;
	}
	return;
}



/** ޥɡ
 *@param[in,out]	apct				̿Ѿ
 *
 *@author	G-HAL
 *@date		Sun,25 Aug,2013, Wed,28 Aug,2013
 */
void parseline_keycmd_enter(struct agent_parser_context_transaction_t* const apct)
{
	assert (NULL != apct);

	switch (apct->input_state) {
	case PARSELINE_INPUT_STATE_INIT:
		break;

	case PARSELINE_INPUT_STATE_INPUT:
	case PARSELINE_INPUT_STATE_CONV:
	case PARSELINE_INPUT_STATE_EDITSEG:
		parseline_keycmd_commit(apct);
		break;
	}
	apct->input_state = PARSELINE_INPUT_STATE_INIT;
	return;
}



/** ޥɡ
 *@param[in,out]	apct				̿Ѿ
 *
 *@author	G-HAL
 *@date		Sun,25 Aug,2013, Wed,28 Aug,2013, Sat,31 Aug,2013
 *@date		Thu,19 Sep,2013
 */
void parseline_keycmd_esc(struct agent_parser_context_transaction_t* const apct)
{
	assert (NULL != apct);

	switch (apct->input_state) {
	case PARSELINE_INPUT_STATE_INIT:
	case PARSELINE_INPUT_STATE_INPUT:
		apct->input.pending_str[0] = '\0';
		apct->input.len = 0;
		apct->input.cursor_ptr = 0;
		apct->input_state = PARSELINE_INPUT_STATE_INIT;
		break;

	case PARSELINE_INPUT_STATE_CONV:
	case PARSELINE_INPUT_STATE_EDITSEG:
		{
			const bool ret_cp = cannaprotocol_EndConvert(apct->cpct, false, 1, apct->converted.selected_candidacy);
			if (!ret_cp) {
				parseline_show_err(apct);
			}
		}
		apct->input_state = PARSELINE_INPUT_STATE_INPUT;
		break;
	}
	return;
}



/** ޥɡʸ
 *@param[in,out]	apct				̿Ѿ
 *
 *@author	G-HAL
 *@date		Sun,25 Aug,2013, Sat,31 Aug,2013
 *@date		Sat,14 Sep,2013
 *@date		Thu,19 Sep,2013
 */
void parseline_keycmd_backspace(struct agent_parser_context_transaction_t* const apct)
{
	assert (NULL != apct);

	switch (apct->input_state) {
	case PARSELINE_INPUT_STATE_INIT:
		break;

	case PARSELINE_INPUT_STATE_INPUT:
		{
			const size_t len_pending_str = strlen(apct->input.pending_str);
			const int_fast16_t cursor_ptr = apct->input.cursor_ptr;
			if (0 < len_pending_str) {
				apct->input.pending_str[len_pending_str-1] = '\0';
			} else if (0 < cursor_ptr) {
				if (apct->break_into_roman) {
					while (0 < apct->input.cursor_ptr) {
						const bool hit = (-1 != (apct->input.str_rk[apct->input.cursor_ptr - 1][0])) ? true : false;
						if (hit) {
							strlcpy(&(apct->input.pending_str[0]), &(apct->input.str_rk[apct->input.cursor_ptr - 1][0]), number_(apct->input.pending_str));
							const size_t new_len_pending_str = strlen(apct->input.pending_str);
							if (0 < new_len_pending_str) {
								apct->input.pending_str[new_len_pending_str-1] = '\0';
							}
						}
						memmove(&(apct->input.str[apct->input.cursor_ptr - 1]), &(apct->input.str[apct->input.cursor_ptr]), (sizeof(apct->input.str[0]) * (size_t)(apct->input.len - apct->input.cursor_ptr)));
						memmove(&(apct->input.str_rk[apct->input.cursor_ptr - 1][0]), &(apct->input.str_rk[apct->input.cursor_ptr][0]), (sizeof(apct->input.str_rk[0]) * (size_t)(apct->input.len - apct->input.cursor_ptr)));
						-- apct->input.cursor_ptr;
						-- apct->input.len;
						if (hit) {
							break;
						}
					}

				} else {
					memmove(&(apct->input.str[cursor_ptr - 1]), &(apct->input.str[cursor_ptr]), (sizeof(apct->input.str[0]) * (size_t)(apct->input.len - cursor_ptr)));
					memmove(&(apct->input.str_rk[cursor_ptr - 1][0]), &(apct->input.str_rk[cursor_ptr][0]), (sizeof(apct->input.str_rk[0]) * (size_t)(apct->input.len - cursor_ptr)));
					-- apct->input.cursor_ptr;
					-- apct->input.len;
				}
			}
		}
		break;

	case PARSELINE_INPUT_STATE_CONV:
	case PARSELINE_INPUT_STATE_EDITSEG:
		{
			const bool ret_cp = cannaprotocol_EndConvert(apct->cpct, false, 1, apct->converted.selected_candidacy);
			if (!ret_cp) {
				parseline_show_err(apct);
			}
		}
		apct->input_state = PARSELINE_INPUT_STATE_INPUT;
		break;
	}
	return;
}



/** ޥɡʸ
 *@param[in,out]	apct				̿Ѿ
 *
 *@author	G-HAL
 *@date		Sun,25 Aug,2013, Sat,31 Aug,2013
 *@date		Sat,14 Sep,2013
 */
void parseline_keycmd_delete(struct agent_parser_context_transaction_t* const apct)
{
	assert (NULL != apct);

	switch (apct->input_state) {
	case PARSELINE_INPUT_STATE_INIT:
		break;

	case PARSELINE_INPUT_STATE_INPUT:
		{
			const size_t len_pending_str = strlen(apct->input.pending_str);
			const int_fast16_t cursor_ptr = apct->input.cursor_ptr;
			if (0 < len_pending_str) {
			} else if (cursor_ptr < apct->input.len) {
				if (apct->break_into_roman) {
					do {
						memmove(&(apct->input.str[cursor_ptr]), &(apct->input.str[cursor_ptr + 1]), (sizeof(apct->input.str[0]) * (size_t)(apct->input.len - cursor_ptr)));
						memmove(&(apct->input.str_rk[cursor_ptr][0]), &(apct->input.str_rk[cursor_ptr + 1][0]), (sizeof(apct->input.str_rk[0]) * (size_t)(apct->input.len - cursor_ptr)));
						-- apct->input.len;
						if (apct->input.len <= cursor_ptr) {
							break;
						}
						if (-1 == apct->input.str_rk[cursor_ptr][0]) {
							continue;
						}
						break;
					} while (true);

				} else {
					memmove(&(apct->input.str[cursor_ptr]), &(apct->input.str[cursor_ptr + 1]), (sizeof(apct->input.str[0]) * (size_t)(apct->input.len - cursor_ptr)));
					memmove(&(apct->input.str_rk[cursor_ptr][0]), &(apct->input.str_rk[cursor_ptr + 1][0]), (sizeof(apct->input.str_rk[0]) * (size_t)(apct->input.len - cursor_ptr)));
					-- apct->input.len;
				}
			}
		}
		break;

	case PARSELINE_INPUT_STATE_CONV:
	case PARSELINE_INPUT_STATE_EDITSEG:
		break;
	}
	return;
}



/** ޥɡ֤ܰư
 *@param[in,out]	apct				̿Ѿ
 *@param			dir					ư-1, +1
 *
 *@author	G-HAL
 *@date		Sun,25 Aug,2013, Wed,28 Aug,2013 - Sat,31 Aug,2013
 */
void parseline_keycmd_arrow_lr(struct agent_parser_context_transaction_t* const apct, int dir)
{
	assert (NULL != apct);

	switch (apct->input_state) {
	case PARSELINE_INPUT_STATE_INIT:
		break;

	case PARSELINE_INPUT_STATE_INPUT:
		{
			if ('\0' != apct->input.pending_str[0]) {
				apct->input.pending_str[0] = '\0';
			} else {
				int_fast16_t new_ptr = apct->input.cursor_ptr + dir;
				if ((0 <= new_ptr) && (new_ptr <= apct->input.len)) {
					apct->input.cursor_ptr = new_ptr;
				}
			}
		}
		break;

	case PARSELINE_INPUT_STATE_CONV:
	case PARSELINE_INPUT_STATE_EDITSEG:
		{
			int_fast16_t new_ptr = apct->converted.cursor_ptr + dir;
			if ((0 <= new_ptr) && (new_ptr < apct->converted.num_phrase)) {
				apct->converted.cursor_ptr = new_ptr;
			}
		}
		break;
	}
	return;
}



/** ޥɡʸĹѹ
 *@param[in,out]	apct				̿Ѿ
 *@param			dir					-1, +1
 *
 *@author	G-HAL
 *@date		Sun,25 Aug,2013, Sun,01 Sep,2013
 *@date		Thu,19 Sep,2013
 */
void parseline_keycmd_shift_arrow_lr(struct agent_parser_context_transaction_t* const apct, int dir)
{
	assert (NULL != apct);

	switch (apct->input_state) {
	case PARSELINE_INPUT_STATE_INIT:
	case PARSELINE_INPUT_STATE_INPUT:
		break;

	case PARSELINE_INPUT_STATE_CONV:
	case PARSELINE_INPUT_STATE_EDITSEG:
		{
			int_fast16_t phrase = apct->converted.cursor_ptr;
			int_fast16_t new_len = apct->converted.len_yomi[phrase] + dir;
			const int_fast16_t limit_new_len = (apct->input.len - apct->converted.ptr_yomi[phrase]);
			if (new_len < 1) {
				new_len = 1;
			} else if (limit_new_len < new_len) {
				new_len = limit_new_len;
			}
			const bool ret_cprp = cannaprotocol_ResizePause(apct->cpct, phrase, new_len, apct->converted.cp.str, number_(apct->converted.cp.str), &(apct->converted.num_phrase));
			if (ret_cprp) {
				const bool ret_cp_getcandidacy = parseline_get_candidacy(apct);
				if (!ret_cp_getcandidacy) {
					goto CONVERT_FAILED;
				}
				apct->converted.selected_candidacy[phrase] = -1;
				for (++phrase; phrase < apct->converted.num_phrase; ++phrase) {
					apct->converted.selected_candidacy[phrase] = 0;
				}
				apct->input_state = PARSELINE_INPUT_STATE_EDITSEG;

			} else {
CONVERT_FAILED:
				parseline_show_err(apct);
				const bool ret_cp = cannaprotocol_EndConvert(apct->cpct, false, 1, apct->converted.selected_candidacy);
				if (!ret_cp) {
				}
			}
		}
		break;
	}
	return;
}



/** ޥɡGo BOL
 *@param[in,out]	apct				̿Ѿ
 *
 *@author	G-HAL
 *@date		Sun,25 Aug,2013, Sat,31 Aug,2013
 */
void parseline_keycmd_gobol(struct agent_parser_context_transaction_t* const apct)
{
	assert (NULL != apct);

	switch (apct->input_state) {
	case PARSELINE_INPUT_STATE_INIT:
		break;

	case PARSELINE_INPUT_STATE_INPUT:
		apct->input.cursor_ptr = 0;
		break;

	case PARSELINE_INPUT_STATE_CONV:
	case PARSELINE_INPUT_STATE_EDITSEG:
		apct->converted.cursor_ptr = 0;
		break;
	}
	return;
}



/** ޥɡGo EOL
 *@param[in,out]	apct				̿Ѿ
 *
 *@author	G-HAL
 *@date		Sun,25 Aug,2013, Sat,31 Aug,2013
 */
void parseline_keycmd_goeol(struct agent_parser_context_transaction_t* const apct)
{
	assert (NULL != apct);

	switch (apct->input_state) {
	case PARSELINE_INPUT_STATE_INIT:
		break;

	case PARSELINE_INPUT_STATE_INPUT:
		apct->input.cursor_ptr = apct->input.len;
		break;

	case PARSELINE_INPUT_STATE_CONV:
	case PARSELINE_INPUT_STATE_EDITSEG:
		apct->converted.cursor_ptr = apct->converted.num_phrase - 1;
		break;
	}
	return;
}



/** ޥɡ
 *@param[in,out]	apct				̿Ѿ
 *
 *@author	G-HAL
 *@date		Sun,25 Aug,2013, Sat,31 Aug,2013
 */
void parseline_keycmd_cut(struct agent_parser_context_transaction_t* const apct)
{
	assert (NULL != apct);

	switch (apct->input_state) {
	case PARSELINE_INPUT_STATE_INIT:
		break;

	case PARSELINE_INPUT_STATE_INPUT:
		apct->input.len = apct->input.cursor_ptr;
		break;

	case PARSELINE_INPUT_STATE_CONV:
	case PARSELINE_INPUT_STATE_EDITSEG:
		break;
	}
	return;
}

/* [ End of File ] */
