/**@file
 *@brief	饤󥹾ࡦС󡦥ӥϿ
 *@date		Tue,10 Sep,2013 - Sun,15 Sep,2013
 *@author	Copyright(C)2011-2013 G-HAL
 *@version	$Id: revision_header.h 46 2013-09-29 00:00:00Z G-HAL $
 *
 *@note
 *@verbatim
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

* Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

* Neither the name of the copyright holders nor the names of its contributors
may be used to endorse or promote products derived from this software
without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *@endverbatim
 */
#ifndef revision_header_h_included_
#define revision_header_h_included_

#include "revision_id.h"



#ifdef __cplusplus
extern "C" {
#endif



#if !defined(HAVE_MERGESORT) || !defined(HAVE_STRLCAT) || !defined(HAVE_STRLCPY)
# if !defined(HAVE_MERGESORT)
#  if !defined(HAVE_STRLCAT)
#   define	_BSD_LIBC_LICENSE_1	"" HAVE_ALTERNATIVE_MERGESORT "()," HAVE_ALTERNATIVE_STRLCAT "()"
#  else
#   define	_BSD_LIBC_LICENSE_1	"" HAVE_ALTERNATIVE_MERGESORT "()"
#  endif
#  if !defined(HAVE_STRLCPY) && !defined(HAVE_LIBBSD)
#   define	_BSD_LIBC_LICENSE_2	"" _BSD_LIBC_LICENSE_1 "," HAVE_ALTERNATIVE_STRLCPY "()"
#  else
#   define	_BSD_LIBC_LICENSE_2	"" _BSD_LIBC_LICENSE_1 ""
#  endif
#  define	_BSD_LIBC_LICENSE_3	"" _BSD_LIBC_LICENSE_2 " are BSD License."
# else
#  if !defined(HAVE_STRLCAT) && !defined(HAVE_LIBBSD)
#   if !defined(HAVE_STRLCPY)
#    define	_BSD_LIBC_LICENSE_3	"" HAVE_ALTERNATIVE_STRLCAT "()," HAVE_ALTERNATIVE_STRLCPY "() are BSD License."
#   else
#    define	_BSD_LIBC_LICENSE_3	"" HAVE_ALTERNATIVE_STRLCAT "() is BSD License."
#   endif
#  else
#   if !defined(HAVE_STRLCPY) && !defined(HAVE_LIBBSD)
#    define	_BSD_LIBC_LICENSE_3	"" HAVE_ALTERNATIVE_STRLCPY "() is BSD License."
#   else
#    define	_BSD_LIBC_LICENSE_3	""
#   endif
#  endif
# endif
# define	BSD_LIBC_LICENSE	" " _BSD_LIBC_LICENSE_3 "."
#else
# define	BSD_LIBC_LICENSE	""
#endif



#define PACKAGE_ID	"" PACKAGE_NAME "-" PACKAGE_VERSION ""
#define REVISION_ID	"$Id: revision_header.h 46 2013-09-29 00:00:00Z G-HAL $"

#if defined(HAVE_ATTRIBUTE_USED)
# define	ATTRIBUTE_USED	__attribute__((used))
#else
# define	ATTRIBUTE_USED
#endif
static const char ATTRIBUTE_USED license[] = "@(#) $license: " PACKAGE_NAME ", BSD 3-Clause License." BSD_LIBC_LICENSE " $";
#if defined(REVISION_SVN)
static const char ATTRIBUTE_USED rcsid[] = "@(#) $version: " REVISION_SVN " $";
#else
static const char ATTRIBUTE_USED rcsid[] = "@(#) $version: " PACKAGE_ID " $";
#endif



#ifdef __cplusplus
}
#endif

#endif /* revision_header_h_included_ */
/* [ End of File ] */
